import 'package:frebu/frebu.dart';
import 'package:uuid/uuid.dart';

import 'note.dart';
import 'repository.dart';

class InMemoryNotesRepository extends NotesRepository {
  InMemoryNotesRepository() {
    final uuid = Uuid();
    notes = [Note(uuid.v4(), 'Test'), Note(uuid.v4(), 'Test 2')];

    addAsyncBuilder(
        AsyncAction(_addNote).onData(OnDataEffect(emitter.onNoteAdd)));

    addAsyncBuilder(
        AsyncAction(_fetchNotes).onData(OnDataEffect(emitter.onFetchNotes)));
  }

  List<Note> notes;

  Future<bool> _addNote(AddNote action) async {
    final note = Note(action.id, action.message);
    notes.add(note);
    return true;
  }

  Future<List<Note>> _fetchNotes(FetchNotes action) async {
    return notes.toList();
  }
}
